# Imagine++ Libraries
# Copyright (C) Imagine
# For detailed information: http://imagine.enpc.fr/software

### Visual defs
if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE
                    -D_SCL_SECURE_NO_WARNINGS
                    -DNOMINMAX)
endif()

### Main

if(NOT Imagine_ROOT)
    get_filename_component(Imagine_ROOT "${CMAKE_CURRENT_LIST_DIR}/.." ABSOLUTE)
    # We need this for CMake's include
    list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})
endif()

if(${CMAKE_FIND_PACKAGE_NAME}_FIND_COMPONENTS)
    set(comps ${${CMAKE_FIND_PACKAGE_NAME}_FIND_COMPONENTS})
else()
    set(comps Common Graphics Images LinAlg)
endif()

foreach(comp IN LISTS comps)
    include(UseImagine${comp})
endforeach()

### Backward compatibility
# Use rather directly target_link_libraries
macro(ImagineUseModules _proj)
    foreach(_pkg ${ARGN})
        target_link_libraries(${_proj} PUBLIC Imagine::${_pkg})
    endforeach()
endmacro()

# Use rather directly add_executable
macro(ImagineAddExecutable _proj)
    add_executable(${_proj} ${ARGN})
endmacro()
