# Imagine++ Libraries
# Copyright (C) Imagine
# For detailed information: http://imagine.enpc.fr/software

if(NOT TARGET Imagine::Graphics)
    if(TARGET ImagineGraphics)
        add_library(Imagine::Graphics ALIAS ImagineGraphics)
        set(targ ImagineGraphics)
    else()
        add_library(Imagine::Graphics STATIC IMPORTED)
        set(targ Imagine::Graphics)
        set_property(TARGET Imagine::Graphics PROPERTY IMPORTED_LOCATION "${Imagine_ROOT}/lib/libImagineGraphics.a")
        find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
        find_package(OpenGL)
        if(OpenGL_FOUND)
          set(compGL OpenGL::GL)
        endif()
        include(UseImagineCommon)
        find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Widgets)
        set_property(TARGET Imagine::Graphics PROPERTY INTERFACE_LINK_LIBRARIES
            Qt${QT_VERSION_MAJOR}::Widgets ${compGL} Imagine::Common)
    endif()
    if(ImaginePP_SOURCE_DIR)
        set(d "${ImaginePP_SOURCE_DIR}/Imagine/Graphics/src")
    else()
        set(d "${Imagine_ROOT}/include")
      endif()
    set_property(TARGET ${targ} PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${d})
endif()
